qca_core.h File Reference
`#include "qca_export.h"`
`#include "qca_support.h"`
`#include "qca_tools.h"`
`#include "qca_version.h"`
`#include <QList>`
`#include <QSharedData>`
`#include <QSharedDataPointer>`
`#include <QString>`
`#include <QStringList>`
Include dependency graph for qca_core.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes

class | QCA::Algorithm
class | QCA::AuthTag
class | QCA::BasicContext
class | QCA::BufferedComputation
class | QCA::Provider::Context
class | QCA::Event
class | QCA::EventHandler
class | QCA::Filter
class | QCA::InitializationVector
class | QCA::Initializer
class | QCA::KeyLength
class | QCA::PasswordAsker
class | QCA::Provider
class | QCA::SymmetricKey
class | QCA::TokenAsker

## Namespaces

namespace | QCA

## Macros

#define | QCA_logBinaryMessage(blob, severity)
#define | QCA_logTextMessage(message, severity)

## Typedefs

typedef QList< Provider * > | QCA::ProviderList

## Enumerations

enum | QCA::Direction { QCA::Encode , QCA::Decode }
enum | QCA::MemoryMode { QCA::Practical , QCA::Locking , QCA::LockingKeepPrivileges }

## Functions

QCA_EXPORT void | QCA::appendPluginDiagnosticText (const QString &text)
QCA_EXPORT QString | QCA::appName ()
QCA_EXPORT QString | QCA::arrayToBase64 (const QByteArray &array)
QCA_EXPORT QString | QCA::arrayToHex (const QByteArray &array)
QCA_EXPORT QByteArray | QCA::base64ToArray (const QString &base64String)
QCA_EXPORT void | QCA::clearPluginDiagnosticText ()
QCA_EXPORT QStringList | QCA::defaultFeatures ()
QCA_EXPORT Provider * | QCA::defaultProvider ()
QCA_EXPORT void | QCA::deinit ()
QCA_EXPORT Provider * | QCA::findProvider (const QString &name)
QCA_EXPORT QVariant | QCA::getProperty (const QString &name)
QCA_EXPORT QVariantMap | QCA::getProviderConfig (const QString &name)
QCA_EXPORT QString | QCA::globalRandomProvider ()
QCA_EXPORT bool | QCA::haveSecureMemory ()
QCA_EXPORT bool | QCA::haveSecureRandom ()
QCA_EXPORT bool | QCA::haveSystemStore ()
QCA_EXPORT QByteArray | QCA::hexToArray (const QString &hexString)
QCA_EXPORT void | QCA::init ()
QCA_EXPORT void | QCA::init (MemoryMode m, int prealloc)
QCA_EXPORT bool | QCA::insertProvider (Provider *p, int priority=0)
QCA_EXPORT bool | QCA::isSupported (const char *features, const QString &provider=QString())
QCA_EXPORT bool | QCA::isSupported (const QStringList &features, const QString &provider=QString())
QCA_EXPORT Logger * | QCA::logger ()
QCA_EXPORT QString | QCA::pluginDiagnosticText ()
QCA_EXPORT QStringList | QCA::pluginPaths ()
QCA_EXPORT int | QCA::providerPriority (const QString &name)
QCA_EXPORT ProviderList | QCA::providers ()
QCA_EXPORT int | qcaMajorVersion ()
QCA_EXPORT int | qcaMinorVersion ()
QCA_EXPORT int | qcaPatchVersion ()
QCA_EXPORT int | qcaVersion ()
QCA_EXPORT const char * | qcaVersionStr ()
QCA_EXPORT void | QCA::saveProviderConfig (const QString &name)
QCA_EXPORT void | QCA::scanForPlugins ()
QCA_EXPORT void | QCA::setAppName (const QString &name)
QCA_EXPORT void | QCA::setGlobalRandomProvider (const QString &provider)
QCA_EXPORT void | QCA::setProperty (const QString &name, const QVariant &value)
QCA_EXPORT void | QCA::setProviderConfig (const QString &name, const QVariantMap &config)
QCA_EXPORT void | QCA::setProviderPriority (const QString &name, int priority)
QCA_EXPORT QStringList | QCA::supportedFeatures ()
QCA_EXPORT CertificateCollection | QCA::systemStore ()
QCA_EXPORT void | QCA::unloadAllPlugins ()
QCA_EXPORT bool | QCA::unloadProvider (const QString &name)

## Detailed Description

Header file for core QCA infrastructure.

Note
  You should not use this header directly from an application. You should just use #include <QtCrypto> instead.

## Macro Definition Documentation

## QCA_logTextMessage

#define QCA_logTextMessage | ( |  | message,
|  |  | severity )

Value:
do { \
QCA::Logger::Severity s = severity; \
QCA::Logger *l = QCA::logger(); \
if (s <= l->level()) { \
l->logTextMessage(message, s); \
} \
} while (false)
QCA::Logger
A simple logging system.
Definition qca_support.h:963
QCA::Logger::Severity
Severity
The severity of the message.
Definition qca_support.h:973
QCA::Logger::logTextMessage
void logTextMessage(const QString &message, Severity=Information)
Log a message to all available log devices.
QCA::logger
QCA_EXPORT Logger * logger()
Return a reference to the QCA Logger, which is used for diagnostics and error recording.

Log a text message.

This is an efficient function to avoid overhead of argument executions when log level blocks the message.

Parameters

  message | the text to log
  severity | the type of information to log

Note
  This is a macro, so arguments may or may not be evaluated.

## QCA_logBinaryMessage

#define QCA_logBinaryMessage | ( |  | blob,
|  |  | severity )

Value:
do { \
QCA::Logger::Severity s = severity; \
QCA::Logger *l = QCA::logger(); \
if (s <= l->level()) { \
l->logBinaryMessage(blob, s); \
} \
} while (false)
QCA::Logger::logBinaryMessage
void logBinaryMessage(const QByteArray &blob, Severity=Information)
Log a binary blob to all available log devices.

Log a binary message.

This is an efficient function to avoid overhead of argument executions when log level blocks the message.

Parameters

  blob | the blob to log
  severity | the type of information to log

Note
  This is a macro, so arguments may or may not be evaluated.

## Function Documentation

## qcaVersion()

QCA_EXPORT int qcaVersion | ( |  | ) |

The current version of QCA.

This is equivalent to QCA_VERSION, except it provides a runtime check of the version of QCA that is being used.

## qcaVersionStr()

QCA_EXPORT const char * qcaVersionStr | ( |  | ) |

The current version of QCA.

This is equivalent to QCA_VERSION_STR, except it provides a runtime check of the version of QCA that is being used.

## qcaMajorVersion()

QCA_EXPORT int qcaMajorVersion | ( |  | ) |

The current version of QCA.

This is equivalent to QCA_MAJOR_VERSION, except it provides a runtime check of the version of QCA that is being used.

## qcaMinorVersion()

QCA_EXPORT int qcaMinorVersion | ( |  | ) |

The current version of QCA.

This is equivalent to QCA_MINOR_VERSION, except it provides a runtime check of the version of QCA that is being used.

## qcaPatchVersion()

QCA_EXPORT int qcaPatchVersion | ( |  | ) |

The current version of QCA.

This is equivalent to QCA_PATCH_VERSION, except it provides a runtime check of the version of QCA that is being used.